<template>
    <div>

      <h2>Task Manager</h2>

      <div :style="{'display': 'flex','justify-content':'center','gap':'10px'}">
        <div>
          <label for ="taskTitle">Task</label><br>
          <input :type="text" name = "newTaskTitle" v-model="newTaskTitle" :value= "newTaskTitle" :id ="taskTitle">
        </div>
      <div>
        <label for ="status">Task</label><br>

        <select name="status" :id = "status" v-model="taskStatus">
          <option value="in-progress">in-progress</option>
          <option value="to-do">to-do</option>
        </select>
      </div>

        <div> 
          <br>  
          <button @click="addTask">Add Task</button>  
        </div>
      </div>

      
      <br><br>    
      <div v-show="this.currentTasks.length > 0" > 
        <h2>My Tasks</h2>
        <table>
          <tr>
            <th>Task</th>
            <th>Status</th>
            <th></th>
            <th></th>
          </tr>

          <tr v-for="currentTask in currentTasks" :key="currentTask">

            
            <td v-show="!currentTask.editMode" >{{ currentTask.title }}</td>
            <td v-show="!currentTask.editMode" >{{ currentTask.status }}</td>
            <td v-show="!currentTask.editMode"><button @click="changeMode(currentTask)" >Edit</button></td>
            <td v-show="!currentTask.editMode"><button @click="deleteTask(currentTask.id)">Delete</button></td>

            <td v-show="currentTask.editMode"><input :type="text" :name="updatedTaskTitle" v-model="currentTask.lastTitleValue"></td>
            <td v-show="currentTask.editMode">{{ currentTask.status }}</td>
            <td v-show="currentTask.editMode"><button @click="changeMode(currentTask)">Cancel</button></td>
            <td v-show="currentTask.editMode"><button @click="updateTask(currentTask)">Save</button></td>
          </tr>

        </table>

      </div>


    </div>
    
    </template>
    
    <script>
    import TaskDataService from "./services/TaskDataService"

    export default {
      name: 'App',
      data() {
        
        return {
          currentTasks: [],
          title: "",
          newTaskTitle : "",
          updatedTaskTitle: "",
          message: "",
          taskStatus : "",
    
        };
      },
      created(){
        this.getAllTasks();
        this.taskStatus = "in-progress";
      },

      methods : {

        addTask() {
          if(this.newTaskTitle.length != 0){
          var data = {
            title: this.newTaskTitle,
            status: this.taskStatus,
           };

           console.log(data);
           TaskDataService.create(data)
            .then(res => {
              this.currentTasks.push(
                {'id':res.data.id,'title':res.data.title, 'status':res.data.status,'editMode':false,'lastTitleValue':res.data.title}
                )
                this.newTaskTitle = ""
            }).catch(err => {
              console.log(err);
            });

          } else {
            window.alert("Task cannot be empty");
          }
        },
        getAllTasks(){
          TaskDataService.getAll().then(res=>{
            console.log(res.data)
            for(let i = 0; i < res.data.length; ++i){
              this.currentTasks.push({'id':res.data[i].id, 'title':res.data[i].title,'status':res.data[i].status,'editMode':false, 'lastTitleValue':res.data[i].title});
            }
            
          }).catch(err =>{
            console.log(err);
          })
        },

        deleteTask(id){
          TaskDataService.delete(id).then(() =>{
            this.currentTasks = [];
            this.getAllTasks();

          }).catch(err=>{console.log(err)});
        },  

        changeMode(currentTask){
          currentTask.editMode = !currentTask.editMode;
        },
        
        updateTask(currentTask){
          if (currentTask.lastTitleValue.length ==  0){
            window.alert('Task cannot be empty');
          }
          else {

            TaskDataService.update(currentTask.id,{'title':currentTask.lastTitleValue,'status':currentTask.status})
            .then(()=>{
              currentTask.title = currentTask.lastTitleValue;
              currentTask.editMode = false;
            }).catch(err=>{console.log(err)});
          }
        }
      }

    }
    </script>
    
    <style scoped>
    #app {
      font-family: Avenir, Helvetica, Arial, sans-serif;
      -webkit-font-smoothing: antialiased;
      -moz-osx-font-smoothing: grayscale;
      text-align: center;
      color: #2c3e50;
      margin-top: 60px;
    }

    table,td{
      margin: auto;
      border: 1px solid black;
    }
    td {
      padding: 10px;
    }


    div {
      text-align: center;
    }

    input {
      border: 1.5px solid black;
      border-radius: 5px;
      height: 30px;
    }

    button {
      border-radius: 5px;
    }
    </style>
    